package com.justbuy

import java.io.{ ByteArrayInputStream, ByteArrayOutputStream, FileOutputStream }

import akka.actor.ActorSystem
import akka.http.scaladsl.Http
import akka.http.scaladsl.marshallers.sprayjson.SprayJsonSupport._
import akka.http.scaladsl.model.{ ContentTypes, HttpEntity }
import akka.http.scaladsl.server.Directives._
import akka.http.scaladsl.server.Route
import akka.stream.ActorMaterializer
import com.amazonaws.auth.{ AWSStaticCredentialsProvider, BasicAWSCredentials }
import com.amazonaws.regions.Regions
import com.amazonaws.services.s3.AmazonS3ClientBuilder
import com.amazonaws.services.s3.model.{ CannedAccessControlList, ObjectMetadata, PutObjectRequest }
import org.apache.commons.codec.binary.Base64
import spray.json.DefaultJsonProtocol

import scala.concurrent.Future
final case class Post(name: String, id: Long, image: String)
//final case class Order(items: List[Item])

object MainApp extends DefaultJsonProtocol {
  // needed to run the route
  implicit val system = ActorSystem()
  implicit val materializer = ActorMaterializer()
  // needed for the future map/flatmap in the end
  implicit val executionContext = system.dispatcher
  val bucketName = "justbuy"
  val AWS_ACCESS_KEY = "AKIAIRBW7PAAM5V6NNYQ"
  val AWS_SECRET_KEY = "Vbh1wHv3Ekm0RLNde1a/+6sKNRy/asfHM9OAy6wE"

  val yourAWSCredentials = new BasicAWSCredentials(AWS_ACCESS_KEY, AWS_SECRET_KEY)
  val s3Client = AmazonS3ClientBuilder.standard().withRegion(Regions.US_EAST_1)
    .withCredentials(new AWSStaticCredentialsProvider(yourAWSCredentials))
    .build();
  //  implicit val itemFormat = jsonFormat2(Item)
  implicit val orderFormat = jsonFormat3(Post)
  def savePost(post: Post): Future[String] = {
    val imgByte = Base64.decodeBase64(post.image.getBytes("UTF-8"))
    val bout = new ByteArrayOutputStream()
    val bis = new ByteArrayInputStream(imgByte)

    val out = new FileOutputStream("avt.png"); ;
    bout.write(imgByte)
    bout.writeTo(out)

    val md = new ObjectMetadata
    val request = new PutObjectRequest(bucketName, "sample.png", bis, md);
    request.setCannedAcl(CannedAccessControlList.PublicRead);

    val result = s3Client.putObject(request)
    bout.close()
    bis.close()
    Future{ result.getContentMd5 }
  }

  val route: Route =
    get {
      pathPrefix("hello") {
        complete(HttpEntity(ContentTypes.`text/html(UTF-8)`, "<h1>Say hello to akka-http</h1>"))
      }
    } ~
      post {
        path("postitem") {
          entity(as[Post]) { post =>

            val saved: Future[String] = savePost(post)
            onComplete(saved) { done =>
              complete(saved)
            }
          }
        }
      }
  Http().bindAndHandle(route, "0.0.0.0", 9000) map { result =>
    println("Server has started on port 9000")
  } recover {
    case ex: Exception => println(s"Server binding failed due to ${ex.getMessage}")
  }
}
