package com.justbuy

import akka.actor.{ ActorRef, ActorSystem, Props }
import akka.cluster.Cluster
import akka.event.{ Logging, LoggingAdapter }
import akka.http.scaladsl.model.StatusCodes
import akka.http.scaladsl.server.Directives._
import akka.http.scaladsl.server.Route
import akka.stream.ActorMaterializer
import com.justbuy.actors.{ Frontend }
import com.justbuy.common.Add
import com.justbuy.db.ConfigCassandraCluster

import scala.concurrent.ExecutionContext
import scala.util.Random

trait Routes extends ConfigCassandraCluster {
  private var _frontend: ActorRef = _

  implicit val actorSystem = ActorSystem("ClusterSystem", clusterconfig)
  implicit val executor: ExecutionContext = actorSystem.dispatcher
  implicit val log: LoggingAdapter = Logging(actorSystem, getClass)
  implicit val materializer: ActorMaterializer = ActorMaterializer()
  actorSystem.log.info("Frontend will start when 2 backend members in the cluster.")
  //#registerOnUp
  Cluster(actorSystem) registerOnMemberUp {
    _frontend = actorSystem.actorOf(Props[Frontend], name = "frontend")

  }
  def getFrontend = _frontend
  val route: Route = {
    get {
      pathPrefix("hello") {
        _frontend ! Add(Random.nextInt(100), Random.nextInt(100))
        complete(StatusCodes.Accepted)
        //complete(HttpEntity(ContentTypes.`text/html(UTF-8)`, "<h1>Say hello to akka-http</h1>"))
      }
      //    }~
      //      post {
      //        path("postitem") {
      //          entity(as[Post]) { post =>
      //            frontend ! Add(Random.nextInt(100), Random.nextInt(100))
      //            complete(StatusCodes.Accepted)
      //
      //          }
      //          }
      //        }
    }
  }
}
//  val route: Route =
//    get {
//      pathPrefix("hello") {
//        complete(HttpEntity(ContentTypes.`text/html(UTF-8)`, "<h1>Say hello to akka-http</h1>"))
//      }
//    }

//  ~
//      post {
//        path("postitem") {
//          entity(as[Post]) { post =>
//
//            val saved: Future[String] = savePost(post)
//            onComplete(saved) { done =>
//              complete(saved)
//            }
//          }
//        }
//      }

