package com.justbuy.db

import com.datastax.driver.core.{ Cluster, ProtocolOptions }
import com.justbuy.util.Config

trait CassandraCluster {
  def cluster: Cluster
}

trait ConfigCassandraCluster extends CassandraCluster with Config {

  lazy val cluster: Cluster =
    Cluster.builder().
      addContactPoints(hosts: _*).
      withCompression(ProtocolOptions.Compression.SNAPPY).
      withPort(port).
      build()
}