package com.justbuy.util

import com.typesafe.config.ConfigFactory

trait Config {

  import scala.collection.JavaConversions._

  private val config = ConfigFactory.load()
  private val httpConfig = config.getConfig("http")

  val httpHost = httpConfig.getString("interface")
  val httpPort = httpConfig.getInt("port")
  private val cassandraConfig = config.getConfig("akka-cassandra.main.db.cassandra")
  val port = cassandraConfig.getInt("port")
  val hosts = cassandraConfig.getStringList("hosts").toList
  val clusterconfig = ConfigFactory.parseString("akka.cluster.roles = [frontend]").
    withFallback(ConfigFactory.load("loadbalancer"))

}
